# Replay an Assembly

POST`https://api2.transloadit.com/assemblies/{ASSEMBLY_ID}/replay`

###### Warning

This endpoint requires your Auth Key to have the `assemblies:write` scope.

If an Assembly crashed, and if we can recover the input files, Transloadit can retry its execution.

You can specify a new `notify_url` parameter in `params` to avoid replaying the URL already specified for the Assembly.

Specify the `steps` parameter to override the Steps of the original Assemblybeing replayed.

The newly created Assembly will have a `parent_assembly_status` in its Status, pointing to the URL of the original crashed Assembly that it is a Replay of.

## POST fields

* Passing `signature` is required. For more information, please check [Signature Authentication](/docs/api/authentication.md).
* Passing `params` is required. It should contain a JSON encoded object with the keys as shown in the table below.

## Supported keys inside the `params` field

* ### `auth` — **required**

`object`\
Contains at least your Transloadit Auth Key in the `key` property.\
If you enable Signature Authentication, you must also set an expiry date for the request in the expires property:\
![](/_next/static/media/copy.04p1cju9qekk_.svg?dpl=dpl_CtwzFbHWtqiCy9uvWb9fE7WvfP9N)

```jsonc
{  
  "key": "23c96d084c744219a2ce156772ec3211",  
  "expires": "2009-08-28T01:02:03.000Z"  
}  
```

We strongly recommend including the `nonce` property — a randomly generated, unique value per request that prevents duplicate processing upon retries, can aid in debugging, and avoids attack vectors such as signature key reuse:\
![](/_next/static/media/copy.04p1cju9qekk_.svg?dpl=dpl_CtwzFbHWtqiCy9uvWb9fE7WvfP9N)

```jsonc
{  
  // …  
  "nonce": "04ac6cb6-df43-41fb-a7fd-e5dd711a64e1"  
}  
```

The `referer` property is a regular expression to match against the HTTP referer of this upload, such as `"example\.org"`. Specify this key to make sure that uploads only come from your domain.\
Uploads without a referer will always pass (as they are turned off for some browsers) making this useful in just a handful of use cases. For details about regular expressions, see [Mozilla's RegExp documentation](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global%5FObjects/RegExp).\
The `max_size` property can be used to set a maximum size that an upload can have in bytes, such as `1048576` (1 MB). Specify this to prevent users from uploading excessively large files.\
This can be set as part of the Assembly request or as part of the Template.\
The file size is checked as soon as the upload is started and if it exceeds the maximum size, the entire upload process is canceled and the Assembly will error out, even if it contains files that do not exceed the `max_size` limitation.\
If you want to just ignore the files that exceed a certain size, but process all others, then please use [🤖/file/filter](/docs/robots/file-filter.md).

* ### `steps`

`Record<string, object & object>`\
Contains Assembly Instructions.

* ### `template_id`

`string`\
The ID of the Template that contains your Assembly Instructions. If you set `allow_steps_override` to `false` in your Template, then `steps` and `template_id` will be mutually exclusive — you may supply only one of these parameters.

* ### `notify_url`

`string | null`\
Transloadit can send a Pingback to your server when the Assembly is completed. We’ll send the Assembly status in a form url-encoded JSON string inside of a transloadit field in a multipart POST request to the URL supplied here.

* ### `fields`

`Record<string, any>`\
An object of string keyed values (name -> value) that can be used as Assembly Variables, just like additional form fields can. You can use anything that is JSON stringifyable as a value

* ### `reparse_template` — **required**

`0 | 1`\
Specify `1` to reparse the Template used in your Assembly (useful if the Template changed in the meantime). Alternatively, `0` replays the identical Steps used in the Assembly.

## Response

Here’s an example response body:

![](/_next/static/media/copy.04p1cju9qekk_.svg?dpl=dpl_CtwzFbHWtqiCy9uvWb9fE7WvfP9N)

```
{
  "ok": "ASSEMBLY_REPLAYING"
}
```

We either return the success code `ASSEMBLY_REPLAYING` or an[error response code](/docs/api/response-codes.md) detailing what went wrong.
